function loadConfig () {
	var rand = Math.random(9999);
	var pars = 'xml=true&config=true&rand=' + rand;
	var req = new Ajax.Request( 'index.php', {method: 'get', parameters: pars, onComplete: updateConfig} );
}

function updateConfig (obj) {
	var xml = obj.responseXML;
	var _params = xml.getElementsByTagName('param');

	for (var i=0;i<_params.length;i++) {
		switch (_params[i].getAttribute('key')) {
			case 'sawdog_status_maxage': {
				sd.maxage = parseInt(_params[i].getAttribute('value'));
				break;
			}
			case 'sawdog_reload': {
				sd.reload = parseInt(_params[i].getAttribute('value'));
				break;
			}
			case 'sawdog_maxtimeouts': {
				sd.maxtimeouts = parseInt(_params[i].getAttribute('value'));
				break;
			}
		}
	}
}

function loadHosts () {
	var rand = Math.random(9999);
	var pars = 'xml=true&rand=' + rand;
	var req = new Ajax.Request( 'index.php', {method: 'get', parameters: pars, onComplete: updateHosts, onFailure: registerFailure} );
}

function updateHosts (obj) {
	var xml = obj.responseXML;
	var _hosts = xml.getElementsByTagName('host');

	$('lastupdated').getElementsByTagName('span')[0].innerHTML = xml.getElementsByTagName('rsp')[0].getAttribute('timestamp');
	new Effect.Highlight($('lastupdated').getElementsByTagName('span')[0], {duration: 0.5});

	if (xml.getElementsByTagName('rsp')[0].getAttribute('offset') >= sd.maxage) {
		showWarning();
	} else {
		hideWarning();
	}

	for (var i=0;i<_hosts.length;i++) {
		var _host = $(_hosts[i].getAttribute('id'));
		var _protocols = _hosts[i].getElementsByTagName('protocol');
		var needsHighlight = false;
		for (var ii=0;ii<_protocols.length;ii++) {
			var _li = $(_hosts[i].getAttribute('id') + '-' + _protocols[ii].getAttribute('name'));
			if (_li.className != _protocols[ii].getAttribute('status')) {
				_li.className = _protocols[ii].getAttribute('status');
				_li.getElementsByTagName('span')[0].innerHTML = 'is ' + _protocols[ii].getAttribute('status');
				needsHighlight = true;
			}
		}
		if (needsHighlight) {
			new Effect.Pulsate(_host);
		}
	}

	sd.failures = 0;
	hideError();
}

function registerFailure () {
	sd.failures++;
	if (sd.failures >= sd.maxtimeouts) {
		showError();
	}
}

function showWarning () {
	var el = $('warning');
	el.innerHTML = '<strong>Warning:</strong> The status file is older than ' + (sd.maxage /60) + ' minutes. Sawdog might be down.';
	el.style.display = 'block';
	Effect.Pulsate(el);
}

function hideWarning () {
	Effect.Fade('warning');
}

function showError () {
	var el = $('error');
	el.innerHTML = '<strong>Error:</strong> The server is not responding.';
	el.style.display = 'block';
	Effect.Pulsate(el);
}

function hideError () {
	Effect.Fade('error');
}

function SawDog () {
	this.failures = 0;
	this.maxage = 900;
	this.reload = 5;
	this.maxtimeouts = 3;
}

var behaviours = {
	'#nav-about' : function (el) {
		el.onclick = function () {
			Effect.BlindDown('about');
			return false;
		}
	}, 
	'#about a.close' : function (el) {
		el.onclick = function () {
			Effect.Fade('about');
			return false;
		}
	}
};
	
Behaviour.register(behaviours);

var sd = new SawDog();
loadConfig();
setTimeout('new PeriodicalExecuter(loadHosts, sd.reload)', 3000); // give loadConfig() some time
